<?php
require_once($_SERVER['DOCUMENT_ROOT'].'/wp-load.php');

/**
* @package PHCityHype 2024
* @author Festus Allasseh   
* @version 2.0
*/
// Code without conditional check
// This will not terminate the script even if 'go' key is not present

if (!isset($_GET['go'])) {
    // No action is taken here, so the script will continue executing
    // even if 'go' key is not present in the URL
}

// Rest of your code here
$alb = 'phcityhype.com.ng';
$cover = 'https://phcityhype.com.ng/ultra/cover.jpg';
$jingle = 'https://phcityhype.com.ng/ultra/jingle.mp3';
$watermark = 'https://phcityhype.com.ng/ultra/watermark.png';
error_reporting(0);
require ('getid3/getid3.php');
if (isset($_POST['submit'])) {
    $now = time();
    $default_mp3_directory = "../wp-content/uploads/";
    $default_album = "@phcityhype";
    $default_year = date("Y", $now);
    $default_genre = "@phcityhype";
    $default_producer = '';
    $default_cover = './cover.jpg';
    $shownUrl = 'https://phcityhype.com.ng/wp-content/uploads/';
    # To the real uploads

    $mp3_filepath = trim($_POST['url']);
    $mp3_songname = trim($_POST['title']);
    $mp3_comment = "Downloaded from phcityhype.com.ng";
    $mp3_artist = trim($_POST['artiste']);
    $artiste = $mp3_artist;
    $pFilename = trim($_POST['filename']);
    $mp3_filename = empty($pFilename) ? $mp3_artist . ' - ' . $mp3_songname : $pFilename;
    $mp3_album = empty($_POST['album']) ? $default_album : trim($_POST['album']);
    $mp3_year = empty($_POST['year']) || !is_numeric($_POST['year']) || strlen($_POST['year']) != 4 ? $default_year : $_POST['year'];
    $mp3_genre = empty($_POST['genre']) ? $default_genre : $_POST['genre'];
    $extra = array('year' => $mp3_year, 'genre' => trim($_POST['genre']), 'album' => trim($_POST['album']), 'producer' => !empty($_POST['producer']) ? trim($_POST['producer']) : $default_producer);
    $error = '';

    # Checking the mp3

    if (!filter_var($mp3_filepath, FILTER_VALIDATE_URL)) {
        $error .= 'Invalid File URL<br>';
    } else if (empty($mp3_filename) || empty($mp3_songname) || empty($mp3_artist)) {
        $error .= "Fields Marked * Are Required<br>";
    } else if (!file_exists($default_cover)) {
        $error .= 'The Photo Cover Has Not Been Uploaded';
    } else {
        $timeFolder = date('Y', $now) . '/' . date('m', $now) . '/';
        if (!file_exists($default_mp3_directory . $timeFolder)) {
            mkdir($default_mp3_directory . $timeFolder, 0777, true);
        }
        $invalidchars = array("'", '"', '.', ',');
        $storeName = str_replace($invalidchars, '', $mp3_filename);
        $storeName = preg_replace('/[^A-Z-a-z0-9\-_]/', '_', $storeName);
        $storeName = preg_replace("/_{2,}/", "_", $storeName);
        $storeName .= '.mp3';
        $sname = $default_mp3_directory . $timeFolder . $storeName;
        if (file_exists($sname)) {
            $error = 'File Has Already Been Uploaded As <a href="' . $shownUrl . $timeFolder . $storeName . '">' . $storeName . '</a>';
        } else {
            if (copy($mp3_filepath, $sname)) {
                # Rewrite tags
                $mp3_tagformat = 'UTF-8';
                $mp3_handler = new getID3;
                $mp3_handler->setOption(array('encoding' => $mp3_tagformat));

                # The writer class
                require('getid3/write.php');

                $mp3_writter = new getid3_writetags;
                $mp3_writter->filename = $sname;
                $mp3_writter->tagformats = array('id3v1', 'id3v2.3');
                $mp3_writter->overwrite_tags = true;
                $mp3_writter->tag_encoding = $mp3_tagformat;
                $mp3_writter->remove_other_tags = true;

                $mp3_data['title'][] = $mp3_songname . '';
                $mp3_data['artist'][] = $mp3_artist;
                $mp3_data['album'][] = $mp3_album;
                $mp3_data['year'][] = $mp3_year;
                $mp3_data['genre'][] = $mp3_genre;
                $mp3_data['comment'][] = $mp3_comment;
                $mp3_data['attached_picture'][0]['data'] = file_get_contents($default_cover);
                $mp3_data['attached_picture'][0]['picturetypeid'] = "image/jpeg";
                $mp3_data['attached_picture'][0]['description'] = "Downloaded from phcityhype.com.ng";
                $mp3_data['attached_picture'][0]['mime'] = "image/jpeg";
                $mp3_writter->tag_data = $mp3_data;

                if ($mp3_writter->WriteTags()) {
                    $link = $sname;
                    $shownUrl .= $timeFolder . $storeName;

                    // FIX: Register the MP3 in the WordPress Media Library
                    $wp_filetype = wp_check_filetype(basename($sname), null);
                    $attachment = array(
                        'guid' => $shownUrl,
                        'post_mime_type' => $wp_filetype['type'],
                        'post_title' => preg_replace('/\.[^.]+$/', '', basename($sname)),
                        'post_content' => '',
                        'post_status' => 'inherit'
                    );
                    $attach_id = wp_insert_attachment($attachment, $sname);
                    require_once(ABSPATH . 'wp-admin/includes/image.php');
                    $attach_data = wp_generate_attachment_metadata($attach_id, $sname);
                    wp_update_attachment_metadata($attach_id, $attach_data);
                } else {
                    unlink($sname);
                    $error .= "Failed To Write Tags!" . implode("", $mp3_writter->errors) . '';
                }
            } else {
                $error .= "Unable to tag mp3";
            }
        }
    }
}
?>
<!DOCTYPE html>
<html>
<head><meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>PHCityHype Mp3tag</title>
<meta name="robots" content="noindex,nofollow">
<style>
body { width: 100%;}
.form-container {
  max-width: 400px;
  margin: 0 auto;
  padding: 20px;
  background-color: #f7f7f7;
  border-radius: 4px;
  box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.1);
}

.form-title {
  font-size: 24px;
  font-weight: bold;
  color: #333;
  margin-bottom: 20px;
}

.form-group {
  margin-bottom: 15px;
}

.label {
  display: block;
  font-size: 14px;
  font-weight: bold;
  color: #666;
  margin-bottom: 5px;
}

.form-input {
  width: 100%;
  padding: 10px;
  font-size: 16px;
  border: none;
  border-radius: 4px;
  background-color: #fff;
  color: #333;
  transition: background-color 0.3s ease;
}

.form-input:focus {
  outline: none;
  background-color: #f5f5f5;
  width:100%;
}

.form-button {
  width: 100%;
  padding: 12px;
  font-size: 16px;
  font-weight: bold;
  color: #fff;
  background-color: #000;
  border: none;
  border-radius: 4px;
  cursor: pointer;
  transition: background-color 0.3s ease;
}

.form-button:hover {
  background-color: #0056b3;
}
/* Successful CSS Design Style */
.input-container {
  position: relative;
}

.input-field {
  width: 300px;
  padding: 10px;
  border: none;
  border-bottom: 2px solid #333;
  font-size: 16px;
  color: #333;
  outline: none;
  background-color: #f5f5f5;
}

.copy-button {
  position: absolute;
  top: 0;
  right: 0;
  padding: 10px;
  background-color: #333;
  color: #fff;
  cursor: pointer;
  border: none;
}

/* Error CSS Design Style */
.error-message {
  color: #ff0000;
  font-size: 14px;
  margin-top: 10px;
}

.success-message {
  color: #008000;
  font-size: 14px;
  margin-top: 10px;
}
</style>
</head>
<body>
  <div class="form-container">
    <h1 class="form-title">Tag and Upload MP3</h1>
    <?php if (!empty($error)) : ?>
      <p class="error-message"><?php echo $error; ?></p>
    <?php elseif (isset($shownUrl)) : ?>
      <p class="success-message">File uploaded successfully! <a href="<?php echo $shownUrl; ?>">Click here to view the file</a>.</p>
      <div class="input-container">
        <input type="text" class="input-field" value="<?php echo $shownUrl; ?>" readonly id="fileUrl">
        <button class="copy-button" onclick="copyToClipboard()">Copy</button>
      </div>
    <?php endif; ?>
    <form method="post" action="<?php echo $_SERVER['REQUEST_URI']; ?>">
      <div class="form-group">
        <label for="url" class="label">MP3 File URL*</label>
        <input type="url" name="url" id="url" value="<?php echo $_POST['url']; ?>" class="form-input" placeholder="Enter Mp3 Link" required>
      </div>
      <div class="form-group">
        <label for="title" class="label">Song Title*</label>
        <input type="text" name="title" id="title" value="<?php echo $_POST['title']; ?>" class="form-input" placeholder="Enter Song name" required>
      </div>
      <div class="form-group">
        <label for="artiste" class="label">Artiste*</label>
        <input type="text" name="artiste" id="artiste" value="<?php echo $_POST['artiste']; ?>" class="form-input" placeholder="Enter Artiste name" required>
      </div>
 <div class="form-group">
        <label for="album" class="label">Album</label>
        <input type="text" name="album" id="album" value="<?php echo $_POST['album']; ?>" class="form-input" placeholder="Enter Album name">
      </div>
    <div class="form-group">
        <label for="producer" class="label">Producer</label>
        <input type="text" name="producer" id="producer" value="<?php echo $_POST['producer']; ?>" class="form-input" placeholder="Enter Producer name">
      </div>
      <div class="form-group">
        <button type="submit" name="submit" class="form-button">Tag MP3</button>
      </div>
    </form>
  </div>

  <script>
    function copyToClipboard() {
      var copyText = document.getElementById("fileUrl");
      copyText.select();
      document.execCommand("copy");
      alert("Copied the URL: " + copyText.value);
    }
  </script>
</body>
</html>
